Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/BuildTagLookup.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/BuildTagLookup.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/BuildTagLookup.pm	(revision 34921)
@@ -1945,7 +2419,7 @@
                 if (@masks) {
                     # combine any mask into the format string
-                    $wrStr .= " & $1" if $masks[0] =~ /(0x[\da-f]+)/;
+                    $wrStr .= PodMask($masks[0]);
                     shift @masks;
-                    @vals = grep !/^\[Mask 0x[\da-f]+\]/, @$values;
+                    @vals = grep !/^\[val( >> \d+)? \& 0x[\da-f]+\]/, @$values;
                 } else {
                     @vals = @$values;
@@ -1958,5 +2432,5 @@
                     $vals[$i] = $$writable[$i] unless defined $vals[$i];
                     if (@masks) {
-                        $vals[$i] .= " & $1" if $masks[0] =~ /(0x[\da-f]+)/;
+                        $vals[$i] .= PodMask($masks[0]);
                         shift @masks;
                     }
@@ -1964,5 +2438,5 @@
                 if ($$sepTable{$vals[0]}) {
                     $wrStr =~ s/^[-=]//;
-                    $wrStr = 'N' unless $wrStr;
+                    $wrStr = 'no' unless $wrStr;
                 } elsif ($$structs{$vals[0]}) {
                     my $flags = $wrStr =~ /([+_]+)$/ ? $1 : '';
@@ -1972,5 +2446,5 @@
                 }
                 shift @vals;
-            } elsif ($wrStr and $wrStr ne 'N' and @masks) {
+            } elsif ($wrStr and $wrStr ne 'no' and @masks) {
                 # fill in missing entries if masks are different
                 my $mask = shift @masks;
@@ -1981,16 +2455,37 @@
                 }
                 # add Mask to Writable column in POD doc
-                $wrStr .= " & $1" if $mask =~ /(0x[\da-f]+)/;
-            }
-            printf PODFILE "%s%-${wTag2}s", $idStr, $tag;
-            warn "Warning: Pushed $tag\n" if $id and length($tag) > $wTag2;
-            printf PODFILE " %-${wGrp}s", shift(@wGrp) || '-' if $showGrp;
+                $wrStr .= PodMask($mask);
+            }
+            my $pod = sprintf "%s%-${wTag2}s", $idStr, $tag;
+            my $tGrp = $wGrp;
+            if ($id and length($tag) > $wTag2) {
+                my $madeRoom;
+                if ($showGrp) {
+                    my $wGrp0 = length($wGrp[0] || '-');
+                    if (not $composite and $wGrp > $wGrp0) {
+                        $tGrp = $wGrp - (length($tag) - $wTag2);
+                        if ($tGrp < length $wGrp0) {
+                            $tGrp = length $wGrp0;
+                        } else {
+                            $madeRoom = 1;
+                        }
+                    }
+                }
+                warn "Warning: Pushed $tag\n" unless $madeRoom;
+            }
+            $pod .= sprintf " %-${tGrp}s", shift(@wGrp) || '-' if $showGrp;
             if ($composite) {
                 @reqs = @$require;
                 $w = $wReq; # Keep writable column in line
                 length($tag) > $wTag2 and $w -= length($tag) - $wTag2;
-                printf PODFILE " %-${w}s", shift(@reqs) || '';
-            }
-            printf PODFILE " $wrStr\n";
+                $pod .= sprintf " %-${w}s", shift(@reqs) || '';
+            }
+            $pod .= " $wrStr";
+            # limit line length to 82 characters (even if it means messing up column alignment)
+            if (length $pod > 82 and $pod !~ /\n/) {
+                my $remove = length($pod) - 82;
+                $pod =~ s/(\w)\s{$remove}/$1/;
+            }
+            print PODFILE $pod, "\n";
             my $numTags = scalar @$tagNames;
             my $n = 0;
@@ -2019,5 +2514,5 @@
                         $line .= " $val";
                         if (@masks) {
-                            $line .= " & $1" if $masks[0] =~ /(0x[\da-f]+)/;
+                            $line .= PodMask($masks[0]);
                             shift @masks;
                         }
@@ -2031,6 +2526,7 @@
                 push @htmlTags, EscapeHTML($_);
             }
-            if (($isExif and $exifSpec{hex $tagIDstr}) or
-                ($isRiff and $tagIDstr=~/(\w+)/ and $riffSpec{$1}))
+            if (($isExif and $Image::ExifTool::Validate::exifSpec{hex $tagIDstr}) or
+                ($isRiff and $tagIDstr=~/(\w+)/ and $riffSpec{$1}) or
+                ($isXmpMain and $tagIDstr=~/([-\w]+)/ and $xmpSpec{$1}))
             {
                 # underline "unknown" makernote tags only
@@ -2045,6 +2541,6 @@
             }
             # add tooltip for hex conversion of Tag ID
-            if ($tagIDstr =~ /^0x[0-9a-f]+$/i) {
-                $tip = sprintf(" title='$tagIDstr = %u'",hex $tagIDstr);
+            if ($tagIDstr =~ /^(0x[0-9a-f]+)(\.\d+)?$/i) {
+                $tip = sprintf(" title='$tagIDstr = %u%s'", hex($1), $2||'');
             } elsif ($tagIDstr =~ /^(\d+)(\.\d*)?$/) {
                 $tip = sprintf(" title='%u = 0x%x'", $1, $1);
@@ -2059,13 +2555,14 @@
                 '_' => 'Flattened',
                 '+' => 'List',
-                '/' => 'Avoided',
+                '/' => 'Avoid',
                 '~' => 'Writable only with -n',
                 '!' => 'Unsafe',
                 '*' => 'Protected',
                 ':' => 'Mandatory',
+                '^' => 'Deletable',
             );
             my ($wstr, %hasAttr, @hasAttr);
             foreach $wstr (@$writable) {
-                next unless $wstr =~ m{([+/~!*:_]+)$};
+                next unless $wstr =~ m{([+/~!*:_^]+)$};
                 my @a = split //, $1;
                 foreach (@a) {
@@ -2098,4 +2595,5 @@
                     foreach (@$values) {
                         if (/^\(/) {
+                            $_ = Doc2Html($_);
                             # set the note font
                             $smallNote = 1 if $numTags < 2;
@@ -2104,5 +2602,13 @@
                         }
                         # make text in square brackets small
-                        /^\[/ and push(@values, "<span class=s>$_</span>"), next;
+                        if (/^\[/) {
+                            if (s/^\[!HTML\]//) {
+                                push @values, $_;
+                            } else {
+                                $_ = Doc2Html($_);
+                                push @values, "<span class=s>$_</span>";
+                            }
+                            next;
+                        }
                         /=/ and push(@values, $_), next;
                         my @names = split;
@@ -2112,13 +2618,17 @@
                             $suffix = ' Values';
                         }
-                        # currently all structures are in XMP documentation
-                        if ($$structs{$_} and $short =~ /^XMP/) {
-                            unshift @names, 'XMP';
+                        # handle structures specially
+                        if ($$structs{$_}) {
+                            # assume XMP module for this struct unless otherwise specified
+                            unshift @names, 'XMP' unless / /;
                             push @structs, $_;  # list this later
+                            # hack to put Area Struct in with XMP tags,
+                            # even though it is only used by the MWG module
+                            push @structs, 'Area' if $_ eq 'Dimensions';
                             $suffix = ' Struct';
                         }
                         $url = (shift @names) . '.html';
                         @names and $url .= '#' . join '_', @names;
-                        push @values, "--&gt; <a href='$url'>$_$suffix</a>";
+                        push @values, "--&gt; <a href='${url}'>$_$suffix</a>";
                     }
                     # put small note last
@@ -2151,6 +2661,10 @@
             print HTMLFILE "</td></tr>\n";
         }
+        warn "$longTags unaccounted-for long tags in $tableName\n" if $longTags;
+        if ($wasLong and not defined $longTags) {
+            warn "Notice: Long tags in $tableName table\n";
+        }
         unless ($infoCount) {
-            printf PODFILE "  [no tags known]\n";
+            print PODFILE "  [no tags known]\n";
             my $cols = 3;
             ++$cols if $hid;
@@ -2182,5 +2696,6 @@
 Image::ExifTool::TagNames.pod, as well as HTML tag name documentation.  It
 is used before each new ExifTool release to update the lookup tables and
-documentation, but it is not used otherwise.
+documentation, but it is not used otherwise.  It also performs some
+validation and consistency checks on the tag tables.
 
 =head1 SYNOPSIS
@@ -2190,7 +2705,15 @@
   $builder = new Image::ExifTool::BuildTagLookup;
 
+  # update Image::ExifTool::TagLookup
   $ok = $builder->WriteTagLookup('lib/Image/ExifTool/TagLookup.pm');
 
+  # update the tag name documentation
   $ok = $builder->WriteTagNames('lib/Image/ExifTool/TagNames.pod','html');
+
+  # print some statistics
+  my $count = $$builder{COUNT};
+  foreach (sort keys %$count) {
+      printf "%5d %s\n", $$count{$_}, $_;
+  }
 
 =head1 MEMBER VARIABLES
@@ -2210,9 +2733,13 @@
 WriteTagNames().
 
+=item WRITE_PSEUDO
+
+Returned list of writable pseudo tags.
+
 =back
 
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
